﻿#if USE_UNI_LUA
using LuaAPI = UniLua.Lua;
using RealStatePtr = UniLua.ILuaState;
using LuaCSFunction = UniLua.CSharpFunctionDelegate;
#else
using LuaAPI = XLua.LuaDLL.Lua;
using RealStatePtr = System.IntPtr;
using LuaCSFunction = XLua.LuaDLL.lua_CSFunction;
#endif

using XLua;
using System.Collections.Generic;


namespace XLua.CSObjectWrap
{
    using Utils = XLua.Utils;
    public class UnityEngineRenderingUniversalInternalColorGradingLutPassWrap 
    {
        public static void __Register(RealStatePtr L)
        {
			ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
			System.Type type = typeof(UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass);
			Utils.BeginObjectRegister(type, L, translator, 0, 3, 0, 0);
			
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Setup", _m_Setup);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "Execute", _m_Execute);
			Utils.RegisterFunc(L, Utils.METHOD_IDX, "FrameCleanup", _m_FrameCleanup);
			
			
			
			
			
			Utils.EndObjectRegister(type, L, translator, null, null,
			    null, null, null);

		    Utils.BeginClassRegister(type, L, __CreateInstance, 1, 0, 0);
			
			
            
			
			
			
			Utils.EndClassRegister(type, L, translator);
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int __CreateInstance(RealStatePtr L)
        {
            
			try {
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
				if(LuaAPI.lua_gettop(L) == 3 && translator.Assignable<UnityEngine.Rendering.Universal.RenderPassEvent>(L, 2) && translator.Assignable<UnityEngine.Rendering.Universal.PostProcessData>(L, 3))
				{
					UnityEngine.Rendering.Universal.RenderPassEvent _evt;translator.Get(L, 2, out _evt);
					UnityEngine.Rendering.Universal.PostProcessData _data = (UnityEngine.Rendering.Universal.PostProcessData)translator.GetObject(L, 3, typeof(UnityEngine.Rendering.Universal.PostProcessData));
					
					UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass gen_ret = new UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass(_evt, _data);
					translator.Push(L, gen_ret);
                    
					return 1;
				}
				
			}
			catch(System.Exception gen_e) {
				return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
			}
            return LuaAPI.luaL_error(L, "invalid arguments to UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass constructor!");
            
        }
        
		
        
		
        
        
        
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Setup(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.Universal.RenderTargetHandle _internalLut;translator.Get(L, 2, out _internalLut);
                    
                    gen_to_be_invoked.Setup( ref _internalLut );
                    translator.Push(L, _internalLut);
                        translator.Update(L, 2, _internalLut);
                        
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_Execute(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.ScriptableRenderContext _context;translator.Get(L, 2, out _context);
                    UnityEngine.Rendering.Universal.RenderingData _renderingData;translator.Get(L, 3, out _renderingData);
                    
                    gen_to_be_invoked.Execute( _context, ref _renderingData );
                    translator.Push(L, _renderingData);
                        translator.Update(L, 3, _renderingData);
                        
                    
                    
                    
                    return 1;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
        static int _m_FrameCleanup(RealStatePtr L)
        {
		    try {
            
                ObjectTranslator translator = ObjectTranslatorPool.Instance.Find(L);
            
            
                UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass gen_to_be_invoked = (UnityEngine.Rendering.Universal.Internal.ColorGradingLutPass)translator.FastGetCSObj(L, 1);
            
            
                
                {
                    UnityEngine.Rendering.CommandBuffer _cmd = (UnityEngine.Rendering.CommandBuffer)translator.GetObject(L, 2, typeof(UnityEngine.Rendering.CommandBuffer));
                    
                    gen_to_be_invoked.FrameCleanup( _cmd );
                    
                    
                    
                    return 0;
                }
                
            } catch(System.Exception gen_e) {
                return LuaAPI.luaL_error(L, "c# exception:" + gen_e);
            }
            
        }
        
        
        
        
        
        
		
		
		
		
    }
}
